/**
 * This file is ran after each invocation of npm shrinkwrap
 * The goal is to remove dependencies that are affected by a shrinkwrap-related bug
 * At the time of writing, this is only the fsevents dependency
 *
 * Bug info: https://github.com/npm/npm/issues/2679
 */

let DEPENDENCIES_TO_REMOVE = ['fsevents'];
let SHRINKWRAP_FILE = '../npm-shrinkwrap.json';

console.log('Removing following dependencies from shrinkwrap as they\'re suffering from an NPM bug', DEPENDENCIES_TO_REMOVE);

let shrinkwrap = require(SHRINKWRAP_FILE);

DEPENDENCIES_TO_REMOVE.forEach(dependency => delete shrinkwrap.dependencies[dependency]);

require('fs').writeFile(SHRINKWRAP_FILE, JSON.stringify(shrinkwrap, null, '  '), 'utf8',
    () => console.log('Done removing buggy dependencies from shrinkwrap'));

