'use strict';
define(function () {

    function OfferParser (offersBreakdown) {
        this.customerSparks = offersBreakdown.sparks || 0;
        this.totalOffers = offersBreakdown.numberOfOffers || 0;
        this.slottedOffers = offersBreakdown.slotted.slots;

        this.unlockedOffers = this.slottedOffers.filter(function (offerSlot) {
            return offerSlot.empty && offerSlot.unlocked;
        });

        this.allBonusOffers = offersBreakdown.allBonusOffers.BONUS.slots
            .concat(offersBreakdown.allBonusOffers.FRIENDS_AND_FAMILY.slots)
            .concat(offersBreakdown.allBonusOffers.FRIENDS_AND_FAMILY_STAFF.slots);

        this.allOffers = this.slottedOffers.concat(this.allBonusOffers);

        this.allActiveOffers = this.allOffers.filter(function (offerSlot) {
            return !offerSlot.available && offerSlot.offer;
        });

        this.availableSlottedOffers = this.slottedOffers.filter(function (offerSlot) {
            return offerSlot.available && offerSlot.free;
        });

        this.availableBonusOffers = this.allBonusOffers.filter(function (offerSlot) {
            return offerSlot.available && offerSlot.free;
        });
    }

    // API
    return {
        parse: function(offersBreakdown) {
            return new OfferParser(offersBreakdown);
        }
    };
});
