var path = require('path');
var entryPoint;
try {
    entryPoint = path.dirname(require.resolve('mns-core-ui-header'));
} catch (e) {
    entryPoint = process.cwd();
}

function getLibrarySourcePath() {
    return path.join('src', 'mns-core-ui-header', 'templates', 'header');
}

function getConfigDataPath() {
    return path.join(entryPoint, getLibrarySourcePath(), 'data', 'mock');
}

module.exports = {
    mockL2Data: function (req, res) {
        res.send(require(path.join(getConfigDataPath(), req.query.mockStoreIdentifier, 'headerL23.js')));
    },

    mockLoyaltyData: function (req, res) {
        res.json(require(path.join(getConfigDataPath(), req.query.mockStoreIdentifier, 'loyalty.js')));
    },

    mockAuthToken: function (req, res) {
        res.json({"token": "qjGGR0VvZQfSfcRgz89iKjBo7OWFP7WLt1eeXasDUGTVweCF"});
    },

    mockMiniBagData: function (req, res) {
        res.json(require(path.join(getConfigDataPath(), req.query.mockStoreIdentifier, 'miniBag.js')));
    },

    mockSavedBasketData: function (req, res) {
        res.json(require(path.join(getConfigDataPath(), req.query.mockStoreIdentifier, 'savedItems.js')));
    },

    mockCountryLinksData: function (req, res) {
        res.json(require(path.join(getConfigDataPath(), req.query.mockStoreIdentifier, 'countryLinksData.js')));
    },

    searchSuggestions: function (req, res) {
        res.send(require(path.join(getConfigDataPath(), req.query.mockStoreIdentifier, 'searchSuggestions.js')));
    }
};
