define(() => {

    function getCarouselWindow(jsdom) {
        jsdom = jsdom.jsdom;
        let html = getHorizontalCarouselDOM() + getVerticalCarouselDOM();
        let doc = jsdom(html);
        let window = doc.defaultView;

        return window;
    }

    function getHorizontalCarouselDOM() {
        let html = '<div id="horizontalCarousel">'
                + '<div class="navigation-hdr-carousel__content" style="width: 400px; height: 100px">'
                + '<ul class="navigation-hdr-carousel__slides">'
                + '<li style="width: 200px; height: 100px">Slide 1</li>'
                + '<li style="width: 200px; height: 100px">Slide 2</li>'
                + '<li style="width: 200px; height: 100px">Slide 3</li>'
                + '<li style="width: 200px; height: 100px">Slide 1</li>'
                + '<li style="width: 200px; height: 100px">Slide 2</li>'
                + '</ul>'
                + '</div>'
                + '<a href="#" class="navigation-hdr-carousel__btn--previous">next</a>'
                + '<a href="#" class="navigation-hdr-carousel__btn--next">previous</a>'
                + '</div>';

        return html;
    }

    function getVerticalCarouselDOM() {
        let html = '<div id="verticalCarousel">'
                + '<div class="navigation-hdr-carousel__content" style="width: 100px; height: 100px">'
                + '<ul class="navigation-hdr-carousel__slides">'
                + '<li style="width: 100px; height: 100px">Slide 1</li>'
                + '<li style="width: 100px; height: 100px">Slide 2</li>'
                + '<li style="width: 100px; height: 100px">Slide 3</li>'
                + '<li style="width: 100px; height: 100px">Slide 1</li>'
                + '<li style="width: 100px; height: 100px">Slide 2</li>'
                + '</ul>'
                + '</div>'
                + '<a href="#" class="navigation-hdr-carousel__btn--previous">next</a>'
                + '<a href="#" class="navigation-hdr-carousel__btn--next">previous</a>'
                + '</div>';

        return html;
    }

    function getDefaultOptions() {
        return {
            wrapper: '.navigation-hdr-carousel__content',
            slider: '.navigation-hdr-carousel__slides',
            slide: '.navigation-hdr-carousel__slides li',
            multiple: true,
            previousBtn: '.navigation-hdr-carousel__btn--previous',
            nextBtn: '.navigation-hdr-carousel__btn--next',
            type: 'horizontal',
            disableBtnCss: 'navigation-hdr-ctrl--link-disable'
        };
    }

    function getCustomOptions() {
        return {
            wrapper: '.navigation-mini-bag__items-wrap',
            slider: '.navigation-hdr-mini-bag__items',
            slide: '.navigation-hdr-mini-bag__items li',
            multiple: true,
            previousBtn: '.navigation-hdr-mini-bag__ctrl--prev .ctrl--link',
            nextBtn: '.navigation-hdr-mini-bag__ctrl--next .ctrl--link',
            type: 'vertical',
            disableBtnCss: 'navigation-hdr-ctrl--link-disable'
        };
    }

    return {
        getCarouselWindow,
        getHorizontalCarouselDOM,
        getVerticalCarouselDOM,
        getDefaultOptions,
        getCustomOptions
    };
});