define(() => {

    function getOverlayDOM() {
        let domEl = document.createElement('div'),
            html = '<div class="navigation-minibag-dock-overlay" style="position: absolute; left:0; top: 0; width: 200px; height: 200px">'
                    + '<div class="navigation-dock-overlay__inner">Dock Overlay</div>'
                    + '</div>';

        domEl.innerHTML = html;

        return domEl.children[0];
    }

    function getOverlayTarget() {
        let domEl = document.createElement('a');

        domEl.innerText = 'Overlay Link';
        domEl.setAttribute('href', '#');
        domEl.className = 'navigation-minibag-dock-overlay-target';

        return domEl;
    }

    function getDefaultOptions() {
        return {
            align: 'center',
            direction: 'down',
            disableCss: 'navigation-dock-overlay--disabled',
            displayCss: 'navigation-dock-overlay--block',
            transitionCss: 'navigation-dock-overlay--transition',
            contentWrapper: '.navigation-dock-overlay__inner'
        };
    }

    function getCustomOptions() {
        return {
            align: 'right',
            direction: 'up',
            disableCss: 'disabled',
            displayCss: 'block',
            transitionCss: 'transition',
            contentWrapper: '.content'
        };
    }

    return {
        getOverlayDOM,
        getOverlayTarget,
        getDefaultOptions,
        getCustomOptions
    };
});