import mnsCookieService from '../../js/links/cookieService';

describe('cookieService', function() {

    afterEach(function() {
        removeCookies();
    });

    describe('isUserLoggedIn method', function() {
        it('should return false if MS_USER_COOKIE not exists', function() {
            expect(mnsCookieService.isUserLoggedIn()).to.not.be.ok;
        });

        it('should return true if MS_USER_COOKIE exists', function() {
            document.cookie = 'MS_USER_COOKIE=TestUser_1234';
            expect(mnsCookieService.isUserLoggedIn()).to.be.ok;
        });
    });

    describe('getUsername method', function() {
        it('should return username from MS_USER_COOKIE', function() {
            document.cookie = 'MS_USER_COOKIE=TestUser_1234';
            expect(mnsCookieService.getUsername()).to.be.equal('TestUser');
        });
    });

    function removeCookies() {
        document.cookie = 'MS_USER_COOKIE=;expires=Thu, 01 Jan 1970 00:00:01 GMT;';
    }
});