define(() => {

    function getContentWindow(jsdom) {
        jsdom = jsdom.jsdom;
        let html = getContent() + getScriptTemplateContent();
        let doc = jsdom(html);
        let window = doc.defaultView;

        return window;
    }

    function getContent() {
        let content = '<div id="loyaltyDropdownWrap">'
            + '<ul>'
            + '<li>'
            + '<a class="navigation-header__sparks-link" data-sparks-login-link="SPARKS_LOGIN_URL" data-sparks-hub-link="SPARKS_HUB_URL">Menu Link</a>'
            + '<div class="navigation-dropdown__panel-wrapper"><div class="navigation-sparks-dropdown__content">'
            + '<p class="navigation-sparks-dropdown__welcome">'
            + '<span class="navigation-sparks-dropdown__user"></span>'
            + '</p>'
            + '<p class="navigation-sparks-dropdown__sparks">'
            + '<span class="navigation-sparks-dropdown__sparks-count"></span>'
            + '</p>'
            + '<ul class="navigation-sparks-dropdown__active-offers">'
            + '<li>'
            + '<a href="{{globalHeader.sparksHubLink}}#">'
            + '<img src="" width="42" height="42" />'
            + '<span></span>'
            + '</a>'
            + '</li>'
            + '</ul>'
            + '<div class="navigation-sparks-dropdown__selectable navigation-sparks-dropdown__avl-offers">'
            + '<a href="#"><div class="navigation-sparks-dropdown__selectable-offer"><span class="navigation-sparks-dropdown__notification"></span></div></a>'
            + '</div>'
            + '<div class="navigation-sparks-dropdown__selectable navigation-sparks-dropdown__avl-bonus-offers">'
            + '<a href="#"><div class="navigation-sparks-dropdown__selectable-offer"><span class="navigation-sparks-dropdown__notification"></span></div></a>'
            + '</div>'
            + '</div>'
            + '<a id="gotoSparksLink" data-sparks-hub-link="SPARKS_HUB_URL" data-sparks-login-link="SPARKS_LOGIN_URL" data-analytics-link-name="ANALYTICS_LINK_NAME" class="btn navigation-btn--north-secondary" href="#">Menu Link</a>'
            + '</div>'
            + '</li>'
            + '</ul>'
            + '</div>';

        return content;
    }

    function getScriptTemplateContent() {
        let content = '<div id="sparksDropdownContentTemplate">'
            + '<p class="navigation-sparks-dropdown__user"></p>'
            + '<p class="navigation-sparks-dropdown__sparks-count"></p>'
            + '</div>';

        return content;
    }

    function getOfferBreakdown() {
        return {
            sparks : '120',
            numberOfOffers: 2,
            slotted: {
                slots: [{
                    empty: false,
                    unlocked: true,
                    available: false,
                    offer: {offerId: 123}
                }, {
                    empty: true,
                    unlocked: true
                }, {
                    empty: true,
                    unlocked: false
                }, {
                    available: true,
                    free: true
                }]
            },
            allBonusOffers: {
                BONUS: {
                    slots: [{
                        empty: false,
                        unlocked: true,
                        available: false,
                        offer: {offerId: 144}
                    }, {
                        available: true,
                        free: true
                    }]
                },
                FRIENDS_AND_FAMILY: {
                    slots: [{
                        empty: false,
                        unlocked: true,
                        available: false,
                        offer: {offerId: 144}
                    }, {
                        available: true,
                        free: true
                    }]
                },
                FRIENDS_AND_FAMILY_STAFF: {
                    slots: [{
                        empty: false,
                        unlocked: true,
                        available: false,
                        offer: {offerId: 144}
                    }, {
                        available: true,
                        free: true
                    }]
                }
            }
        };
    }


    return {
        getContentWindow,
        getContent,
        getScriptTemplateContent,
        getOfferBreakdown
    };
});